﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.UltraChart.Core.Primitives;
using System.Diagnostics;

namespace UltraChartColumn3DChartWithPercents
{
    public partial class Form1 : Form
    {
        private DataTable dt;
        private List<Text> TextList = new List<Text>();

        public Form1()
        {
            dt = new DataTable();
            dt.Columns.Add("A", typeof(decimal));
            dt.Columns.Add("B", typeof(decimal));
            dt.Columns.Add("C", typeof(decimal));

            dt.Rows.Add(10, 20, 15);
            dt.Rows.Add(15, 10, 25);
            //dt.Rows.Add(30, 25, 10);
            
            InitializeComponent();
            ultraChart1.DataSource = dt;
        }

        private void ultraChart1_FillSceneGraph(object sender, Infragistics.UltraChart.Shared.Events.FillSceneGraphEventArgs e)
        {
            TextList.Clear();
            string IsAddedKey = null;

            foreach (Primitive pr in e.SceneGraph)
            {
                if (pr.Row != -1 && pr.Column != -1 && IsAddedKey != (pr.Row.ToString() + "-" + pr.Column.ToString()))
                {
                    decimal tempPercent= (Convert.ToDecimal(pr.Value) / CalcSum(dt.Rows[pr.Row]))*100;
                    Text textLable = new Text(new Point((int)((Infragistics.UltraChart.Core.Primitives.Path)(pr)).GraphicsPath.PathPoints[0].X, (int)((Infragistics.UltraChart.Core.Primitives.Path)(pr)).GraphicsPath.PathPoints[0].Y), tempPercent.ToString("0.00") + " %");
                    textLable.PE.Fill = Color.Black;
                    IsAddedKey = pr.Row.ToString() + "-" + pr.Column.ToString();
                    TextList.Add(textLable);
                }
            }
            foreach (var item in TextList.Distinct()) 
                e.SceneGraph.Add(item);
        }

        private decimal CalcSum(DataRow dr)
        {
            decimal sum =0;

            foreach (decimal item in dr.ItemArray)
            {
                sum += item;
            }
            return sum;
        }
    }
}
